;==============================================================================
    include \masm32\include\masm32rt.inc
    .686
    include \masm32\macros\timers.asm
    include stackprobe.inc
;==============================================================================
    .data
        hHeap dd 0
        pMem  dd 0
    .code
;==============================================================================

OPTION PROLOGUE:STACKPROBE
Stack4 proc
    local buff[4096*4]:BYTE
    mov byte ptr [esp], 1
    ret
Stack4 endp
OPTION PROLOGUE:PROLOGUEDEF

;==============================================================================

ReAlloc4 proc
    invoke HeapReAlloc, hHeap, HEAP_GENERATE_EXCEPTIONS, pMem, 4096*4
    mov pMem, eax
    ret
ReAlloc4 endp

;==============================================================================

OPTION PROLOGUE:STACKPROBE
Stack16 proc
    local buff[4096*16]:BYTE
    mov byte ptr [esp], 1
    ret
Stack16 endp
OPTION PROLOGUE:PROLOGUEDEF

;==============================================================================

ReAlloc16 proc
    invoke HeapReAlloc, hHeap, HEAP_GENERATE_EXCEPTIONS, pMem, 4096*16
    mov pMem, eax
    ret
ReAlloc16 endp

;==============================================================================

OPTION PROLOGUE:STACKPROBE
Stack64 proc
    local buff[4096*64]:BYTE
    mov byte ptr [esp], 1
    ret
Stack64 endp
OPTION PROLOGUE:PROLOGUEDEF

;==============================================================================

ReAlloc64 proc
    invoke HeapReAlloc, hHeap, HEAP_GENERATE_EXCEPTIONS, pMem, 4096*64
    mov pMem, eax
    ret
ReAlloc64 endp

;==============================================================================
start:
;==============================================================================

    ;-----------------------------------------------------
    ; Create a growable heap with an initial aize of 1MB.
    ;-----------------------------------------------------

    invoke HeapCreate, HEAP_GENERATE_EXCEPTIONS, 100000h, 0
    mov hHeap, eax

    ;-------------------------------------
    ; Allocate a 4KB block from the heap.
    ;-------------------------------------

    invoke HeapAlloc, hHeap, HEAP_GENERATE_EXCEPTIONS, 4096
    mov pMem, eax

    invoke Sleep, 4000

    repeat 3

      counter_begin 1000, HIGH_PRIORITY_CLASS
        invoke Stack4
      counter_end
      print str$(eax)," cycles, 16KB from stack",13,10

      counter_begin 1000, HIGH_PRIORITY_CLASS
        invoke ReAlloc4
      counter_end
      print str$(eax)," cycles, 16KB with realloc",13,10

      counter_begin 1000, HIGH_PRIORITY_CLASS
        invoke Stack16
      counter_end
      print str$(eax)," cycles, 64KB from stack",13,10

      counter_begin 1000, HIGH_PRIORITY_CLASS
        invoke ReAlloc16
      counter_end
      print str$(eax)," cycles, 64KB with realloc",13,10

      counter_begin 1000, HIGH_PRIORITY_CLASS
        invoke Stack64
      counter_end
      print str$(eax)," cycles, 256KB from stack",13,10

      counter_begin 1000, HIGH_PRIORITY_CLASS
        invoke ReAlloc64
      counter_end
      print str$(eax)," cycles, 256KB with realloc",13,10,13,10

    endm

    inkey "Press any key to exit..."
    exit
;==============================================================================
end start